
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Coupon_redemptionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coupon_redemptions = await db.coupon_redemptions.create(
            {
                id: data.id || undefined,
        
        redeemed_at: data.redeemed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await coupon_redemptions.setCoupon( data.coupon || null, {
            transaction,
        });
        
        await coupon_redemptions.setUser( data.user || null, {
            transaction,
        });
        
        await coupon_redemptions.setOrder( data.order || null, {
            transaction,
        });
        

        

        

        return coupon_redemptions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const coupon_redemptionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                redeemed_at: item.redeemed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const coupon_redemptions = await db.coupon_redemptions.bulkCreate(coupon_redemptionsData, { transaction });

        // For each item created, replace relation files
        

        return coupon_redemptions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const coupon_redemptions = await db.coupon_redemptions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.redeemed_at !== undefined) updatePayload.redeemed_at = data.redeemed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await coupon_redemptions.update(updatePayload, {transaction});

        
        
        if (data.coupon !== undefined) {
            await coupon_redemptions.setCoupon(
              
              data.coupon,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await coupon_redemptions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.order !== undefined) {
            await coupon_redemptions.setOrder(
              
              data.order,
              
              { transaction }
            );
        }
        

        
        

        

        return coupon_redemptions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coupon_redemptions = await db.coupon_redemptions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of coupon_redemptions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of coupon_redemptions) {
                await record.destroy({transaction});
            }
        });


        return coupon_redemptions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const coupon_redemptions = await db.coupon_redemptions.findByPk(id, options);

        await coupon_redemptions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await coupon_redemptions.destroy({
            transaction
        });

        return coupon_redemptions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const coupon_redemptions = await db.coupon_redemptions.findOne(
            { where },
            { transaction },
        );

        if (!coupon_redemptions) {
            return coupon_redemptions;
        }

        const output = coupon_redemptions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.coupon = await coupon_redemptions.getCoupon({
            transaction
        });
        
        
        output.user = await coupon_redemptions.getUser({
            transaction
        });
        
        
        output.order = await coupon_redemptions.getOrder({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.coupons,
        as: 'coupon',
        
        where: filter.coupon ? {
          [Op.or]: [
            { id: { [Op.in]: filter.coupon.split('|').map(term => Utils.uuid(term)) } },
            {
              code: {
                [Op.or]: filter.coupon.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.orders,
        as: 'order',
        
        where: filter.order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.redeemed_atRange) {
                const [start, end] = filter.redeemed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    redeemed_at: {
                    ...where.redeemed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    redeemed_at: {
                    ...where.redeemed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.coupon_redemptions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'coupon_redemptions',
                        'redeemed_at',
                        query,
                    ),
                ],
            };
        }

        const records = await db.coupon_redemptions.findAll({
            attributes: [ 'id', 'redeemed_at' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['redeemed_at', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.redeemed_at,
        }));
    }

    
};

